from __future__ import absolute_import, division, print_function
standard_cif_links = [
  ['link_ACE_C-N', 'ACE_C-N from Monomer Library or GeoStd'],
  ['link_AHT-ALA', 'AHT-ALA from Monomer Library or GeoStd'],
  ['link_ALPHA1-2', 'ALPHA1-2 from Monomer Library or GeoStd'],
  ['link_ALPHA1-3', 'ALPHA1-3 from Monomer Library or GeoStd'],
  ['link_ALPHA1-4', 'ALPHA1-4 from Monomer Library or GeoStd'],
  ['link_ALPHA1-6', 'ALPHA1-6 from Monomer Library or GeoStd'],
  ['link_ALPHA2-3', 'ALPHA2-3 from Monomer Library or GeoStd'],
  ['link_ALPHA2-6', 'ALPHA2-6 from Monomer Library or GeoStd'],
  ['link_BETA1-2', 'BETA1-2 from Monomer Library or GeoStd'],
  ['link_BETA1-3', 'BETA1-3 from Monomer Library or GeoStd'],
  ['link_BETA1-4', 'BETA1-4 from Monomer Library or GeoStd'],
  ['link_BETA1-6', 'BETA1-6 from Monomer Library or GeoStd'],
  ['link_BETA2-3', 'BETA2-3 from Monomer Library or GeoStd'],
  ['link_BOC_C-N', 'BOC_C-N from Monomer Library or GeoStd'],
  ['link_BR-C5', 'BR-C5 from Monomer Library or GeoStd'],
  ['link_CH2-N2', 'CH2-N2 from Monomer Library or GeoStd'],
  ['link_CH3-N1', 'CH3-N1 from Monomer Library or GeoStd'],
  ['link_CH3-O2*', 'CH3-O2* from Monomer Library or GeoStd'],
  ['link_CIS', 'CIS from Monomer Library or GeoStd'],
  ['link_CYS-MPR', 'CYS-MPR from Monomer Library or GeoStd'],
  ['link_DFO-NME', 'DFO-NME from Monomer Library or GeoStd'],
  ['link_DFO_C-N', 'DFO_C-N from Monomer Library or GeoStd'],
  ['link_DFO_DFO', 'DFO_DFO from Monomer Library or GeoStd'],
  ['link_DFO_N-C', 'DFO_N-C from Monomer Library or GeoStd'],
  ['link_DFO_STA', 'DFO_STA from Monomer Library or GeoStd'],
  ['link_DM1-CH2', 'DM1-CH2 from Monomer Library or GeoStd'],
  ['link_FE-CYS', 'FE-CYS from Monomer Library or GeoStd'],
  ['link_FOR-LYZ', 'FOR-LYZ from Monomer Library or GeoStd'],
  ['link_FOR_C-C', 'FOR_C-C from Monomer Library or GeoStd'],
  ['link_FOR_C-N', 'FOR_C-N from Monomer Library or GeoStd'],
  ['link_ILG_CD-N', 'ILG_CD-N from Monomer Library or GeoStd'],
  ['link_ILG_CD-p', 'ILG_CD-p from Monomer Library or GeoStd'],
  ['link_IVA_C-N', 'IVA_C-N from Monomer Library or GeoStd'],
  ['link_LINK_C-N', 'LINK_C-N from Monomer Library or GeoStd'],
  ['link_LINK_CNp', 'LINK_CNp from Monomer Library or GeoStd'],
  ['link_LINK_CpN', 'LINK_CpN from Monomer Library or GeoStd'],
  ['link_MAN-ASN', 'MAN-ASN from Monomer Library or GeoStd'],
  ['link_MAN-SER', 'MAN-SER from Monomer Library or GeoStd'],
  ['link_MAN-THR', 'MAN-THR from Monomer Library or GeoStd'],
  ['link_MG-O1P', 'MG-O1P from Monomer Library or GeoStd'],
  ['link_MG-O2P', 'MG-O2P from Monomer Library or GeoStd'],
  ['link_MPR-CYS', 'MPR-CYS from Monomer Library or GeoStd'],
  ['link_NAG-ASN', 'NAG-ASN from Monomer Library or GeoStd'],
  ['link_NAG-SER', 'NAG-SER from Monomer Library or GeoStd'],
  ['link_NAG-THR', 'NAG-THR from Monomer Library or GeoStd'],
  ['link_NH2_CTERM', 'NH2_CTERM from Monomer Library or GeoStd'],
  ['link_NMCIS', 'NMCIS from Monomer Library or GeoStd'],
  ['link_NME_N-C', 'NME_N-C from Monomer Library or GeoStd'],
  ['link_NMTRANS', 'NMTRANS from Monomer Library or GeoStd'],
  ['link_PCIS', 'PCIS from Monomer Library or GeoStd'],
  ['link_PEPTIDE-PLANE', 'PEPTIDE-PLANE from Monomer Library or GeoStd'],
  ['link_POST-BETA-TRANS', 'POST-BETA-TRANS from Monomer Library or GeoStd'],
  ['link_PRE-BETA-TRANS', 'PRE-BETA-TRANS from Monomer Library or GeoStd'],
  ['link_PTRANS', 'PTRANS from Monomer Library or GeoStd'],
  ['link_SFN-TYR', 'SFN-TYR from Monomer Library or GeoStd'],
  ['link_SS', 'SS from Monomer Library or GeoStd'],
  ['link_SSRAD', 'SSRAD from Monomer Library or GeoStd'],
  ['link_STA-NME', 'STA-NME from Monomer Library or GeoStd'],
  ['link_STA_C-N', 'STA_C-N from Monomer Library or GeoStd'],
  ['link_STA_DFO', 'STA_DFO from Monomer Library or GeoStd'],
  ['link_STA_N-C', 'STA_N-C from Monomer Library or GeoStd'],
  ['link_STA_STA', 'STA_STA from Monomer Library or GeoStd'],
  ['link_TRANS', 'TRANS from Monomer Library or GeoStd'],
  ['link_XYS-ASN', 'XYS-ASN from Monomer Library or GeoStd'],
  ['link_XYS-SER', 'XYS-SER from Monomer Library or GeoStd'],
  ['link_XYS-THR', 'XYS-THR from Monomer Library or GeoStd'],
  ['link_ZN-CYS', 'ZN-CYS from Monomer Library or GeoStd'],
  ['link_gap', 'gap from Monomer Library or GeoStd'],
  ['link_p', 'p from Monomer Library or GeoStd'],
  ['link_symmetry', 'symmetry from Monomer Library or GeoStd'],
]
