//
#ifndef SOLVENT_DISTRIBUTION_NCO_09MAY2005_SHORT_UNIFORM_H
#define SOLVENT_DISTRIBUTION_NCO_09MAY2005_SHORT_UNIFORM_H

namespace mmtbx { namespace max_lik {

// d_min d_max N C O
double sd_nco_table[][5] = {
    {0.000, 2.500,         0.,         0.,         0.},
    {2.500, 2.510,         0.,         0.,         1.},
    {2.510, 2.520,         0.,         0.,         1.},
    {2.520, 2.530,         0.,         0.,         1.},
    {2.530, 2.540,         0.,         0.,         1.},
    {2.540, 2.550,         0.,         0.,         1.},
    {2.550, 2.560,         0.,         0.,         1.},
    {2.560, 2.570,         0.,         0.,         1.},
    {2.570, 2.580,         0.,         0.,         1.},
    {2.580, 2.590,         0.,         0.,         1.},
    {2.590, 2.600,         0.,         0.,         1.},
    {2.600, 2.610,         0.,         0.,         1.},
    {2.610, 2.620,         0.,         0.,         1.},
    {2.620, 2.630,         0.,         0.,         1.},
    {2.630, 2.640,         0.,         0.,         1.},
    {2.640, 2.650,         0.,         0.,         1.},
    {2.650, 2.660,         0.,         0.,         1.},
    {2.660, 2.670,         0.,         0.,         1.},
    {2.670, 2.680,         0.,         0.,         1.},
    {2.680, 2.690,         0.,         0.,         1.},
    {2.690, 2.700,         0.,         0.,         1.},
    {2.700, 2.710,         1.,         0.,         1.},
    {2.710, 2.720,         1.,         0.,         1.},
    {2.720, 2.730,         1.,         0.,         1.},
    {2.730, 2.740,         1.,         0.,         1.},
    {2.740, 2.750,         1.,         0.,         1.},
    {2.750, 2.760,         1.,         0.,         1.},
    {2.760, 2.770,         1.,         0.,         1.},
    {2.770, 2.780,         1.,         0.,         1.},
    {2.780, 2.790,         1.,         0.,         1.},
    {2.790, 2.800,         1.,         0.,         1.},
    {2.800, 2.810,         1.,         0.,         1.},
    {2.810, 2.820,         1.,         0.,         1.},
    {2.820, 2.830,         1.,         0.,         1.},
    {2.830, 2.840,         1.,         0.,         1.},
    {2.840, 2.850,         1.,         0.,         1.},
    {2.850, 2.860,         1.,         0.,         1.},
    {2.860, 2.870,         1.,         0.,         1.},
    {2.870, 2.880,         1.,         0.,         1.},
    {2.880, 2.890,         1.,         0.,         1.},
    {2.890, 2.900,         1.,         0.,         1.},
    {2.900, 2.910,         1.,         0.,         1.},
    {2.910, 2.920,         1.,         0.,         1.},
    {2.920, 2.930,         1.,         0.,         1.},
    {2.930, 2.940,         1.,         0.,         1.},
    {2.940, 2.950,         1.,         0.,         1.},
    {2.950, 2.960,         1.,         0.,         1.},
    {2.960, 2.970,         1.,         0.,         1.},
    {2.970, 2.980,         1.,         0.,         1.},
    {2.980, 2.990,         1.,         0.,         1.},
    {2.990, 3.000,         1.,         0.,         1.},
    {3.000, 3.010,         1.,         0.,         1.},
    {3.010, 3.020,         1.,         0.,         1.},
    {3.020, 3.030,         1.,         0.,         1.},
    {3.030, 3.040,         1.,         0.,         1.},
    {3.040, 3.050,         1.,         0.,         1.},
    {3.050, 3.060,         1.,         0.,         1.},
    {3.060, 3.070,         1.,         0.,         1.},
    {3.070, 3.080,         1.,         0.,         1.},
    {3.080, 3.090,         1.,         0.,         1.},
    {3.090, 3.100,         1.,         0.,         1.},
    {3.100, 3.110,         1.,         1.,         1.},
    {3.110, 3.120,         1.,         1.,         1.},
    {3.120, 3.130,         1.,         1.,         1.},
    {3.130, 3.140,         1.,         1.,         1.},
    {3.140, 3.150,         1.,         1.,         1.},
    {3.150, 3.160,         1.,         1.,         1.},
    {3.160, 3.170,         1.,         1.,         1.},
    {3.170, 3.180,         1.,         1.,         1.},
    {3.180, 3.190,         1.,         1.,         1.},
    {3.190, 3.200,         1.,         1.,         1.},
    {3.200, 3.210,         0.,         1.,         0.},
    {3.210, 3.220,         0.,         1.,         0.},
    {3.220, 3.230,         0.,         1.,         0.},
    {3.230, 3.240,         0.,         1.,         0.},
    {3.240, 3.250,         0.,         1.,         0.},
    {3.250, 3.260,         0.,         1.,         0.},
    {3.260, 3.270,         0.,         1.,         0.},
    {3.270, 3.280,         0.,         1.,         0.},
    {3.280, 3.290,         0.,         1.,         0.},
    {3.290, 3.300,         0.,         1.,         0.},
    {3.300, 3.310,         0.,         1.,         0.},
    {3.310, 3.320,         0.,         1.,         0.},
    {3.320, 3.330,         0.,         1.,         0.},
    {3.330, 3.340,         0.,         1.,         0.},
    {3.340, 3.350,         0.,         1.,         0.},
    {3.350, 3.360,         0.,         1.,         0.},
    {3.360, 3.370,         0.,         1.,         0.},
    {3.370, 3.380,         0.,         1.,         0.},
    {3.380, 3.390,         0.,         1.,         0.},
    {3.390, 3.400,         0.,         1.,         0.},
    {3.400, 3.410,         0.,         1.,         0.},
    {3.410, 3.420,         0.,         1.,         0.},
    {3.420, 3.430,         0.,         1.,         0.},
    {3.430, 3.440,         0.,         1.,         0.},
    {3.440, 3.450,         0.,         1.,         0.},
    {3.450, 3.460,         0.,         1.,         0.},
    {3.460, 3.470,         0.,         1.,         0.},
    {3.470, 3.480,         0.,         1.,         0.},
    {3.480, 3.490,         0.,         1.,         0.},
    {3.490, 3.500,         0.,         1.,         0.},
    {3.500, 3.510,         0.,         1.,         0.},
    {3.510, 3.520,         0.,         1.,         0.},
    {3.520, 3.530,         0.,         1.,         0.},
    {3.530, 3.540,         0.,         1.,         0.},
    {3.540, 3.550,         0.,         1.,         0.},
    {3.550, 3.560,         0.,         1.,         0.},
    {3.560, 3.570,         0.,         1.,         0.},
    {3.570, 3.580,         0.,         1.,         0.},
    {3.580, 3.590,         0.,         1.,         0.},
    {3.590, 3.600,         0.,         1.,         0.},
    {3.600, 3.610,         0.,         1.,         0.},
    {3.610, 3.620,         0.,         1.,         0.},
    {3.620, 3.630,         0.,         1.,         0.},
    {3.630, 3.640,         0.,         1.,         0.},
    {3.640, 3.650,         0.,         1.,         0.},
    {3.650, 3.660,         0.,         1.,         0.},
    {3.660, 3.670,         0.,         1.,         0.},
    {3.670, 3.680,         0.,         1.,         0.},
    {3.680, 3.690,         0.,         1.,         0.},
    {3.690, 3.700,         0.,         1.,         0.},
    {3.700, 3.710,         0.,         1.,         0.},
    {3.710, 3.720,         0.,         1.,         0.},
    {3.720, 3.730,         0.,         1.,         0.},
    {3.730, 3.740,         0.,         1.,         0.},
    {3.740, 3.750,         0.,         1.,         0.},
    {3.750, 3.760,         0.,         1.,         0.},
    {3.760, 3.770,         0.,         1.,         0.},
    {3.770, 3.780,         0.,         1.,         0.},
    {3.780, 3.790,         0.,         1.,         0.},
    {3.790, 3.800,         0.,         1.,         0.},
    {3.800, 3.810,         0.,         1.,         0.},
    {3.810, 3.820,         0.,         1.,         0.},
    {3.820, 3.830,         0.,         1.,         0.},
    {3.830, 3.840,         0.,         1.,         0.},
    {3.840, 3.850,         0.,         1.,         0.},
    {3.850, 3.860,         0.,         1.,         0.},
    {3.860, 3.870,         0.,         1.,         0.},
    {3.870, 3.880,         0.,         1.,         0.},
    {3.880, 3.890,         0.,         1.,         0.},
    {3.890, 3.900,         0.,         1.,         0.},
    {3.900, 3.910,         0.,         1.,         0.},
    {3.910, 3.920,         0.,         1.,         0.},
    {3.920, 3.930,         0.,         1.,         0.},
    {3.930, 3.940,         0.,         1.,         0.},
    {3.940, 3.950,         0.,         1.,         0.},
    {3.950, 3.960,         0.,         1.,         0.},
    {3.960, 3.970,         0.,         1.,         0.},
    {3.970, 3.980,         0.,         1.,         0.},
    {3.980, 3.990,         0.,         1.,         0.},
    {3.990, 4.000,         0.,         1.,         0.},
    {4.000, 4.010,         0.,         1.,         0.},
    {4.010, 4.020,         0.,         1.,         0.},
    {4.020, 4.030,         0.,         1.,         0.},
    {4.030, 4.040,         0.,         1.,         0.},
    {4.040, 4.050,         0.,         1.,         0.},
    {4.050, 4.060,         0.,         1.,         0.},
    {4.060, 4.070,         0.,         1.,         0.},
    {4.070, 4.080,         0.,         1.,         0.},
    {4.080, 4.090,         0.,         1.,         0.},
    {4.090, 4.100,         0.,         1.,         0.},
    {4.100, 4.110,         0.,         1.,         0.},
    {4.110, 4.120,         0.,         1.,         0.},
    {4.120, 4.130,         0.,         1.,         0.},
    {4.130, 4.140,         0.,         1.,         0.},
    {4.140, 4.150,         0.,         1.,         0.},
    {4.150, 4.160,         0.,         1.,         0.},
    {4.160, 4.170,         0.,         1.,         0.},
    {4.170, 4.180,         0.,         1.,         0.},
    {4.180, 4.190,         0.,         1.,         0.},
    {4.190, 4.200,         0.,         1.,         0.},
    {4.200, 999.990,       0.,         0.,         0.}};


}}
#endif
